## CanJS TodoMVC Demos

This project contains a collection of [TodoMVC](https://github.com/addyosmani/todomvc/) demos using [CanJS](https://github.com/jupiterjs/canjs) with the different libraries that it supports.

### Demos

- [jquery](http://donejs.com/examples/todo/jquery/): CanJS with jQuery
- [jquery-widget](http://donejs.com/examples/todo/jquery-widget/): CanJS with jQuery (includes a jQuery UI widget binding example)
- [dojo](http://donejs.com/examples/todo/dojo/): CanJS with Dojo
- [dojo-widget](http://donejs.com/examples/todo/dojo-widget/): CanJS with Dojo (includes a Dojo widget binding example)
- [mootools](http://donejs.com/examples/todo/mootools/): CanJS with Mootools
- [yui](http://donejs.com/examples/todo/yui/): CanJS with YUI
- [yui-widget](http://donejs.com/examples/todo/yui-widget/): CanJS with YUI (includes a YUI widget binding example)
- [zepto](http://donejs.com/examples/todo/zepto/): CanJS with Zepto

### Getting Started

To get these demos:

1. Download the [latest release](#) or clone the project:
```git clone git@github.com:jupiterjs/cantodo.git```
2. Run these demos on a local server. Open the corresponding, self-named, demo page:

	- `jquery`: `jquery/index.html`
	- `jquery-widget`: `jquery-widget/index.html`
	- `dojo`: `dojo/index.html`
	- `dojo-widget`: `dojo-widget/index.html`
	- `mootools`: `mootools/index.html`
	- `yui`: `yui/index.html`
	- `yui-widget`: `yui-widget/index.html`
	- `zepto`: `zepto/index.html`

You can also use the [links above][demos] to view the demos live on donejs.com.

### Testing

FuncUnit tests for each demo are included in the `test` directory.

To run the unit tests:

1. First update the submodules: 
```git submodule update --init --recursive```
2. Open the corresponding test page:

	- `all frameworks`: `test/index.html`
	- `jquery`: `test/jquery.html`
	- `jquery-widget`: `test/jquery-widget.html`
	- `dojo`: `test/dojo.html`
	- `dojo-widget`: `test/dojo-widget.html`
	- `mootools`: `test/mootools.html`
	- `yui`: `test/yui.html`
	- `yui-widget`: `test/yui-widget.html`
	- `zepto`: `test/zepto.html`

---

Created and maintained by [Bitovi](http://bitovi.com)